Program CBM64; { Mixed (PAS & ASM) version 1 }

{$DEFINE AZERTY - (or QWERTY) }
{-$DEFINE QWERTY}

{$DEFINE SID}
{$DEFINE FM}

{$DEFINE TIMING}
{-$DEFINE PERCENT}

uses
 VGA, DOS,
 {$IFDEF SID}
  {$IFDEF FM}
   SIDFM,
  {$ELSE}
   RESID8,
  {$ENDIF}
 {$ENDIF}
 C64ROM,KEYBOARD,IEC,D64,T64,DATA,DIALOGS;

{$I KEYB.PAS}

const
 one_msec=1193;
var
 old8:pointer;
 clock:word;

procedure new8; far; assembler;
 Asm
  push ax
  push ds
  mov ax,seg @data
  mov ds,ax
  mov al,$20
  out $20,al
  inc [mstimer]
  add [clock],one_msec
  jnc @1
  pushf
  call [old8]
 @1:
  pop ds
  pop ax
  iret
 end;

{$L CBM64.OBJ}
Procedure Startup; external;
Procedure Emulate; external;

{$IFNDEF SID}
Procedure PokeSID; far;
 begin
 end;
{$ENDIF}

Procedure CPUJAM; far;
 var
  s:string;
 begin
  s:='CPU jammed at PC='+HexaW(PC)+' on opcode '+HexaB(opJAM)+#0;
  StatusBar(s);
  GetKey;
 end;

Procedure Pause; far;
 begin
  StatusBar('Press Enter to continue');
  GetKey;
 end;

Procedure Joy1Active; far;
 begin
  StatusBar('Using joystick #1');
  GetKey;
 end;

Procedure Joy2Active; far;
 begin
  StatusBar('Using joystick #2');
  GetKey;
 end;

var
 BIOS:longint absolute $40:$6C;
 tRate:word;
  Time:longint;
  st,ss,sk:string;

Procedure OnSwap; far;
 begin
 {$IFDEF PERCENT}
  Time:=BIOS-Ticks;
  Time:=(Time*10) div 182;
  if time<=0 then exit;
  tRate:=(TotalCycles div (985248 div 100)) div Time;
  str(tRate:3,st);
  str(SkipCount:2,sk);
  Box(0,0,50,10,clWhite);
  OutTextXY(1,1,clBlue,st+'/'+sk);
 {$ENDIF}
 end;

Procedure Timing; far;
 const
  skip:integer=0;
 begin
 {$IFDEF TIMING}
  if mstimer>20 then begin { to slow }
   inc(skip,mstimer-20);   { how many lost ms }
   if (skip>20)and(SkipCount<10) then begin
    inc(SkipCount); { skip one more }
    dec(skip,20);
   end;
  end else begin
   inc(mstimer,skip);
   if mstimer>20 then begin
    skip:=mstimer-20;
   end else begin
    skip:=20-mstimer;
    if skipcount>0 then dec(skipcount);
    repeat until mstimer>=20;
   end;
  (*
   dec(skip,20-mstimer);
   if (skip<0) then begin
    if skipcount>0 then dec(skipcount);
    inc(skip,20);
   end;
   repeat until mstimer>=20; { wait  }
  *)
  end;
  mstimer:=0;
 {$ENDIF}
 end;

Procedure StatusInfo; far;
 const
  top=80;
 var
  str:string;
  m:byte;
 begin
  Frame3D(25,top,310,078,clWhite,ClGrey,clBlue);
   OutTextXY(30,top+5,clGreen,'Status Info');
   OutTextXY(130,top+5,clGrey,'(During VBlank)');

   str:='Video Mode  : ';
   m:=((Mem[CIOSeg:53265] and $60) or (Mem[CIOSeg:53270]and$10)) shr 4;
   case m of
    0 : str:=str+'Standard Text';
    1 : str:=str+'MultiColor Text';
    2 : str:=str+'Standard Bitmap';
    3 : str:=str+'MultiCol.Bitmap';
    4 : str:=str+'Extended Text';
    5 : str:=str+'Ext. MC. Text';
    6 : str:=str+'Invalide Ext.';
    7 : str:=str+'Invalide Ext.MC';
   end;
   OutTextXY(30,top+15,clYellow,str);

   str:='Video Bank  : $'+HexaW(Bank);
   OutTextXY(30,top+25,clYellow,str);

   str:='Scrolling   : X=$'+HexaB(Mem[CIOSeg:53270] and 7)+
                     ' Y=$'+HexaB(Mem[CIOSeg:53265] and 7);
   OutTextXY(30,top+35,clYellow,str);

   if m and 2=0 then begin
    str:='Video Ram   : $'+HexaW(VideoOfs);
    OutTextXY(30,top+45,clYellow,str);

    str:='CharGen     : ';
    if Seg(CharGen^)=RAMSeg then str:=str+'RAM' else
    if Seg(CharGen^)=ROMSeg then str:=str+'ROM' else str:=str+HexaW(Seg(CharGen^));

    str:=str+':'+HexaW(Ofs(CharGen^));

    OutTextXY(30,top+55,clYellow,str);


   end else begin
    str:='Bitmap Addr : $'+HexaW(BitmapOfs);
    OutTextXY(30,top+45,clYellow,str);
   end;

   m:=({(not Mem[RAMSeg:0]) or} Mem[RAMSeg:1]) and $2F;
   str:='CPU port '+HexaB(m)+' : ';
   if (m and 3)=3 then str:=str+'BSC-' else str:=str+'RAM-';
   if (m and 3)=0 then
    str:=str+'RAM-'
   else
    if (m and 4)=4 then str:=str+'CHP-' else str:=str+'CHR-';
   if (m and 2)=2 then str:=str+'KRN' else str:=str+'RAM';
   OutTextXY(30,top+65,clYellow,str);

  { CPU }
   str:='PC='+HexaW(PC); OutTextXY(270,top+5,clLightBlue,str);
   str:=' A='+HexaB(A); OutTextXY(270,top+15,clLightBlue,str);
   str:=' X='+HexaB(X); OutTextXY(270,top+25,clLightBlue,str);
   str:=' Y='+HexaB(Y); OutTextXY(270,top+35,clLightBlue,str);
   str:=' S=1'+HexaB(byte(S)); OutTextXY(270,top+45,clLightBlue,str);

   str:=' P='+HexaB(byte(P));  OutTextXY(270,top+55,clLightBlue,str);
   str:='nv0bdizc';
   if CFlag in P then str[8]:='C';
   if ZFlag in P then str[7]:='Z';
   if IFlag in P then str[6]:='I';
   if DFlag in P then str[5]:='D';
   if BFlag in P then str[4]:='B';
   if _Flag in P then str[3]:='1';
   if VFlag in P then str[2]:='V';
   if NFlag in P then str[1]:='N';
   OutTextXY(268,top+65,clLightBlue,str);

  GetKey;
 end;

var
 k1:byte absolute $40:$17;
           { bit 7 =1 INSert active
             bit 6 =1 Caps Lock active
             bit 5 =1 Num Lock active
             bit 4 =1 Scroll Lock active
             bit 3 =1 either Alt pressed
             bit 2 =1 either Ctrl pressed
             bit 1 =1 Left Shift pressed
             bit 0 =1 Right Shift pressed }
 k2:byte absolute $40:$18;
           { bit 7 =1 INSert pressed
             bit 6 =1 Caps Lock pressed
             bit 5 =1 Num Lock pressed
             bit 4 =1 Scroll Lock pressed
             bit 3 =1 Pause state active
             bit 2 =1 Sys Req pressed
             bit 1 =1 Left Alt pressed
             bit 0 =1 Left Ctrl pressed }
function AnyKey:boolean;
 begin
  AnyKey:=(k2>0)or((k1 and 15)>0)or(Port[$60]<128);
 end;

procedure Setup;
 begin
{ Avoid CTRL(+F9) problem when runing this pgm under BP IDE }
{ check if port[$60]>0 for WINDOWS }
 if (Port[$60]>0) and AnyKey then begin
  writeln('Please, release all keys...');
  while AnyKey do;
 end;

 if paramcount>0 then D64File:=ParamStr(1);

 asm mov ax,03h; int 10h end;

 WriteLn(#16' CBM64 (C)1998, Paul TOTH <tothpaul@multimania.com>');
{$IFDEF AZERTY}
 WriteLn(#16' French (AZERTY) Keyboard');
{$ELSE}
 WriteLn(#16' US (QWERTY) Keyboard');
{$ENDIF}


 WriteLn(#16' Memory setup (',($FFFF+$6000) div 1024,' Ko)');
{ RAM : 0000-FFFF }
{ ROM : 0000-1FFF - BASIC (A000-BFFF) }
{     : 2000-2FFF - CHIPS (D000-DFFF) }
{     : 3000-3FFF - CHARS (D000-DFFF) }
{     : 4000-5FFF - KERNL (E000-FFFF) }
 GetMem(RAM,$FFFF); if RAM=nil then halt; if Ofs(RAM^)>0 then halt;
 GetMem(ROM,$6000); if ROM=nil then halt; if Ofs(ROM^)>0 then halt;
 RAMSeg:=Seg(RAM^);
 ROMSeg:=Seg(ROM^)-$0A00;
 CIOSeg:=Seg(ROM^)-$0D00+$0200;
 VGASeg:=SegA000;
 VGAOfs:=$0000;

{$IFDEF TIMING}
 getintvec(8,old8);
 setintvec(8,@new8);
 Port[$43] := $36;
 Port[$40] := Lo(one_msec);
 Port[$40] := Hi(one_msec);
{$ENDIF}

 TotalCycles:=0;
 SkipCount:=0;
end;

procedure Shutdown;
begin
{$IFDEF TIMING}
 port[$43]:=$36;
 port[$40]:=$00;
 port[$40]:=$00;
 setintvec(8,old8);
{$ENDIF}

 Write(#16' Exit at $',HexaW(PC));
 Write(' Total Cycles=',TotalCycles,' in ',Ticks,' seconds');
 Write(', Rate=',Rate,'%');
 WriteLn(', Frames=',TotalCycles div (63*312));
 WriteLn(#16' TotalCycles/985248 = ',TotalCycles div 985248,' = ',(TotalCycles div 9853) div Ticks,'%');

{$IFDEF SID}
{$IFDEF FM}
 WriteLn(#16' 9 Voice FM SID Emulation by MySelf !');
{$ELSE}
 WriteLn(#16' SID Emulation from reSID by Dag Lem <resid@nimrod.no>');
 Write(#16' SID IRQs=',IRQs);
 WriteLn(', Rate = ',TotalCycles div IRQs div CycleRate,'%');
{$ENDIF}
{$ENDIF}

 Write(#16' Try also "Come Back 64" by Johan Fiti and Brad Martin !');
end;

begin
 Setup;

{$IFDEF SID} Init; {$ENDIF}
 StartUp;
 Emulate;
{$IFDEF SID} Done; {$ENDIF}

 Shutdown;

end.