Program DBG64;

{-$R-,S-,I-,Q-}
{-$D-,L-,Y-}

{-$define verify}

{-$define SID}
{$define trap16}

uses
 C64ROM,IEC,D64,DATA,CRT,FDOS{$IFDEF SID},SIDFM{$ENDIF};

{$L DBG64.OBJ}
Procedure Startup; external;
Procedure Emulate; external;
var volume2:byte;

Procedure OnSwap; far; begin end;
Procedure Timing; far; begin end;

Const
 Info:string='*** C=64 EMULATOR BY PAUL TOTH ***';

 COLOR:array[0..15] of byte=(
  Black,White,Red,Cyan,Magenta,Green,Blue,Yellow,
  LightMagenta,Brown,LightRed,DarkGray,LightGray,
  LightGreen,LightBlue,LightCyan
 );

Var
 CHARSET1:array[0..255] of byte;
 CHARSET2:array[0..255] of byte;

Type
 TParm=(
  p0,
  pImpl, { no parameters }
  pAbso, { word }
  pZPge, { byte }
  pImm,  { #byte }
  pAbsX, { word+x }
  pAbsY, { word+y }
  pIndX, { [byte+x] = array[x]^ }
  pIndY, { [byte]+y = array^[y] }
  pZPgX, { byte+x }
  pZPgY, { byte+y }
  pRela, { shortint(byte) }
  pInd   { [word] }
 );

 TOpCode=record
  Name:array[1..3] of char;
  Parm:TParm;
 end;

Const
 OpCode:Array[0..255] of TOpCode = (
 {00-0F}
  (Name:'BRK'; Parm:pImpl),  (Name:'ORA'; Parm:pIndX),
  (Name:'JAM'; Parm:pImpl),  (Name:'SLO'; Parm:pIndX),
  (Name:'NOP'; Parm:pZpge),  (Name:'ORA'; Parm:pZPge),
  (Name:'ASL'; Parm:pZPge),  (Name:'SLO'; Parm:pZPge),
  (Name:'PHP'; Parm:pImpl),  (Name:'ORA'; Parm:pImm),
  (Name:'ASL'; Parm:pImpl),  (Name:'ANC'; Parm:pImm),
  (Name:'NOP'; Parm:pAbso),  (Name:'ORA'; Parm:pAbso),
  (Name:'ASL'; Parm:pAbso),  (Name:'   '; Parm:p0   ),
 {10-1F}
  (Name:'BPL'; Parm:pRela),  (Name:'ORA'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'SLO'; Parm:pIndY),
  (Name:'NOP'; Parm:pZPgX),  (Name:'ORA'; Parm:pZPgX),
  (Name:'ASL'; Parm:pZPgX),  (Name:'   '; Parm:p0   ),
  (Name:'CLC'; Parm:pImpl),  (Name:'ORA'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'   '; Parm:p0   ),
  (Name:'   '; Parm:p0   ),  (Name:'ORA'; Parm:pAbsX),
  (Name:'ASL'; Parm:pAbsX),  (Name:'   '; Parm:p0   ),
 {20-2F}
  (Name:'JSR'; Parm:pAbso),  (Name:'AND'; Parm:pIndX),
  (Name:'   '; Parm:p0   ),  (Name:'RLA'; Parm:pIndX),
  (Name:'BIT'; Parm:pZPge),  (Name:'AND'; Parm:pZPge),
  (Name:'ROL'; Parm:pZPge),  (Name:'RLA'; Parm:pZPge),
  (Name:'PLP'; Parm:pImpl),  (Name:'AND'; Parm:pImm),
  (Name:'ROL'; Parm:pImpl),  (Name:'   '; Parm:p0   ),
  (Name:'BIT'; Parm:pAbso),  (Name:'AND'; Parm:pAbso),
  (Name:'ROL'; Parm:pAbso),  (Name:'RLA'; Parm:pAbso),
 {30-3F}
  (Name:'BMI'; Parm:pRela),  (Name:'AND'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'RLA'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'AND'; Parm:pZPgX),
  (Name:'ROL'; Parm:pZPgX),  (Name:'RLA'; Parm:pZPgX),
  (Name:'SEC'; Parm:pImpl),  (Name:'AND'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'RLA'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'AND'; Parm:pAbsX),
  (Name:'ROL'; Parm:pAbsX),  (Name:'RLA'; Parm:pAbsX),
 {40-4F}
  (Name:'RTI'; Parm:pImpl),  (Name:'EOR'; Parm:pIndX),
  (Name:'   '; Parm:p0   ),  (Name:'SRE'; Parm:pIndX),
  (Name:'   '; Parm:p0   ),  (Name:'EOR'; Parm:pZPge),
  (Name:'LSR'; Parm:pZPge),  (Name:'   '; Parm:p0   ),
  (Name:'PHA'; Parm:pImpl),  (Name:'EOR'; Parm:pImm ),
  (Name:'LSR'; Parm:pImpl),  (Name:'ASR'; Parm:pImm ),
  (Name:'JMP'; Parm:pAbso),  (Name:'EOR'; Parm:pAbso),
  (Name:'LSR'; Parm:pAbso),  (Name:'SRE'; Parm:pAbso),
 {50-5F}
  (Name:'BVC'; Parm:pRela),  (Name:'EOR'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'SRE'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'EOR'; Parm:pZPgX),
  (Name:'LSR'; Parm:pZPgX),  (Name:'SRE'; Parm:pZPgX),
  (Name:'CLI'; Parm:pImpl),  (Name:'EOR'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'SRE'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'EOR'; Parm:pAbsX),
  (Name:'LSR'; Parm:pAbsX),  (Name:'SRE'; Parm:pAbsX),
 {60-6F}
  (Name:'RTS'; Parm:pImpl),  (Name:'ADC'; Parm:pIndX),
  (Name:'   '; Parm:p0   ),  (Name:'RRA'; Parm:pIndX),
  (Name:'   '; Parm:p0   ),  (Name:'ADC'; Parm:pZPge),
  (Name:'ROR'; Parm:pZPge),  (Name:'RRA'; Parm:pZPge),
  (Name:'PLA'; Parm:pImpl),  (Name:'ADC'; Parm:pImm),
  (Name:'ROR'; Parm:pImpl),  (Name:'   '; Parm:p0   ),
  (Name:'JMP'; Parm:pInd ),  (Name:'ADC'; Parm:pAbso),
  (Name:'ROR'; Parm:pAbso),  (Name:'RRA'; Parm:pAbso),
 {70-7F}
  (Name:'BVS'; Parm:pRela),  (Name:'ADC'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'RRA'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'ADC'; Parm:pZPgX),
  (Name:'ROR'; Parm:pZPgX),  (Name:'RRA'; Parm:pZPgX),
  (Name:'SEI'; Parm:pImpl),  (Name:'ADC'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'RRA'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'ADC'; Parm:pAbsX),
  (Name:'ROR'; Parm:pAbsX),  (Name:'RRA'; Parm:pAbsX),
 {80-8F}
  (Name:'NOP'; Parm:pImm ),  (Name:'STA'; Parm:pIndX),
  (Name:'   '; Parm:p0   ),  (Name:'SAX'; Parm:pIndX),
  (Name:'STY'; Parm:pZPge),  (Name:'STA'; Parm:pZPge),
  (Name:'STX'; Parm:pZPge),  (Name:'SAX'; Parm:pZPge),
  (Name:'DEY'; Parm:pImpl),  (Name:'   '; Parm:p0   ),
  (Name:'TXA'; Parm:pImpl),  (Name:'ANE'; Parm:pImm ),
  (Name:'STY'; Parm:pAbso),  (Name:'STA'; Parm:pAbso),
  (Name:'STX'; Parm:pAbso),  (Name:'SAX'; Parm:pAbso),
 {90-9F}
  (Name:'BCC'; Parm:pRela),  (Name:'STA'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'SHA'; Parm:pIndY),
  (Name:'STY'; Parm:pZPgX),  (Name:'STA'; Parm:pZPgX),
  (Name:'STX'; Parm:pZPgY),  (Name:'SAX'; Parm:pZpgX),
  (Name:'TYA'; Parm:pImpl),  (Name:'STA'; Parm:pAbsY),
  (Name:'TXS'; Parm:pImpl),  (Name:'SHS'; Parm:pAbsY),
  (Name:'SHY'; Parm:pAbsX),  (Name:'STA'; Parm:pAbsX),
  (Name:'SHX'; Parm:pAbsY),  (Name:'SHA'; Parm:pAbsY),
 {A0-AF}
  (Name:'LDY'; Parm:pImm),   (Name:'LDA'; Parm:pIndX),
  (Name:'LDX'; Parm:pImm),   (Name:'LAX'; Parm:pIndX),
  (Name:'LDY'; Parm:pZPge),  (Name:'LDA'; Parm:pZPge),
  (Name:'LDX'; Parm:pZPge),  (Name:'LAX'; Parm:pZPge),
  (Name:'TAY'; Parm:pImpl),  (Name:'LDA'; Parm:pImm),
  (Name:'TAX'; Parm:pImpl),  (Name:'LXA'; Parm:pImm ),
  (Name:'LDY'; Parm:pAbso),  (Name:'LDA'; Parm:pAbso),
  (Name:'LDX'; Parm:pAbso),  (Name:'LAX'; Parm:pAbso),
 {B0-BF}
  (Name:'BCS'; Parm:pRela),  (Name:'LDA'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'LAX'; Parm:pIndY),
  (Name:'LDY'; Parm:pZPgX),  (Name:'LDA'; Parm:pZpgX),
  (Name:'LDX'; Parm:pZPgY),  (Name:'LAX'; Parm:pZpgY),
  (Name:'CLV'; Parm:pImpl),  (Name:'LDA'; Parm:pAbsY),
  (Name:'TSX'; Parm:pImpl),  (Name:'LAS'; Parm:pAbsY),
  (Name:'LDY'; Parm:pAbsX),  (Name:'LDA'; Parm:pAbsX),
  (Name:'LDX'; Parm:pAbsY),  (Name:'LAX'; Parm:pAbsY),
 {C0-CF}
  (Name:'CPY'; Parm:pImm ),  (Name:'CMP'; Parm:pIndX),
  (Name:'   '; Parm:p0   ),  (Name:'DCP'; Parm:pIndX),
  (Name:'CPY'; Parm:pZPge),  (Name:'CMP'; Parm:pZPge),
  (Name:'DEC'; Parm:pZPge),  (Name:'DCP'; Parm:pZPge),
  (Name:'INY'; Parm:pImpl),  (Name:'CMP'; Parm:pImm),
  (Name:'DEX'; Parm:pImpl),  (Name:'SBX'; Parm:pImm ),
  (Name:'CPY'; Parm:pAbso),  (Name:'CMP'; Parm:pAbso),
  (Name:'DEC'; Parm:pAbso),  (Name:'DCP'; Parm:pAbso),
 {D0-DF}
  (Name:'BNE'; Parm:pRela),  (Name:'CMP'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'DCP'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'   '; Parm:p0   ),
  (Name:'DEC'; Parm:pZPgX),  (Name:'DCP'; Parm:pZPgX),
  (Name:'CLD'; Parm:pImpl),  (Name:'CMP'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'DCP'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'CMP'; Parm:pAbsX),
  (Name:'DEC'; Parm:pAbsX),  (Name:'DCP'; Parm:pAbsX),
 {E0-EF}
  (Name:'CPX'; Parm:pImm ),  (Name:'SBC'; Parm:pIndX),
  (Name:'   '; Parm:p0   ),  (Name:'ISB'; Parm:pIndX),
  (Name:'CPX'; Parm:pZPge),  (Name:'SBC'; Parm:pZPge),
  (Name:'INC'; Parm:pZPge),  (Name:'ISB'; Parm:pZPge),
  (Name:'INX'; Parm:pImpl),  (Name:'SBC'; Parm:pImm),
  (Name:'NOP'; Parm:pImpl),  (Name:'   '; Parm:p0   ),
  (Name:'CPX'; Parm:pAbso),  (Name:'SBC'; Parm:pAbso),
  (Name:'INC'; Parm:pAbso),  (Name:'ISB'; Parm:pAbso),
 {F0-FF}
  (Name:'BEQ'; Parm:pRela),  (Name:'SBC'; Parm:pIndY),
  (Name:'D64'; Parm:pImm ),  (Name:'ISB'; Parm:pIndY),
  (Name:'   '; Parm:p0   ),  (Name:'SBC'; Parm:pZPgX),
  (Name:'INC'; Parm:pZPgX),  (Name:'ISB'; Parm:pZPgX),
  (Name:'SED'; Parm:pImpl),  (Name:'SBC'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'ISB'; Parm:pAbsY),
  (Name:'   '; Parm:p0   ),  (Name:'SBC'; Parm:pAbsX),
  (Name:'INC'; Parm:pAbsX),  (Name:'ISB'; Parm:pAbsX)
  );



var
 i:integer;

Const
 Hexa:array[0..$F] of char='0123456789ABCDEF';

Procedure PutHexaB(B:Byte; Var data);
 Var
  HexaB:Array[0..1] of char absolute Data;
 begin
  HexaB[0]:=Hexa[B SHR 4];
  HexaB[1]:=Hexa[B AND $F];
 end;

Procedure PutHexaW(W:Word;Var data);
 var
  hexaw:array[0..1] of word absolute data;
 begin
  PutHexaB(W SHR   8,hexaw[0]);
  PutHexaB(W AND $FF,hexaw[1]);
 end;

Function HexaB(B:Byte):string;
 begin
  HexaB:=Hexa[B SHR 4]+Hexa[B AND $F];
 end;

Function HexaW(W:Word):string;
 begin
  HexaW:=HexaB(W SHR 8)+HexaB(W AND $FF);
 end;

Function Deek(Addr:word):word;
 begin
  case addr of
   $0000..$9FFF : Deek:=MemW[RAMSeg:Addr];
   $A000..$BFFF : Deek:=MemW[ROMSeg:Addr];
   $C000..$CFFF : Deek:=MemW[RAMSeg:Addr];
   $D000..$DFFF : Deek:=MemW[CIOSeg:Addr];
   $E000..$FFFF : Deek:=MemW[ROMSeg:Addr];
  end;
 end;

Function Peek(Addr:word):byte;
 begin
  case addr of
   $0000..$9FFF : Peek:=Mem[RAMSeg:Addr];
   $A000..$BFFF : Peek:=Mem[ROMSeg:Addr];
   $C000..$CFFF : Peek:=Mem[RAMSeg:Addr];
   $D000..$DFFF : Peek:=Mem[CIOSeg:Addr];
   $E000..$FFFF : Peek:=Mem[ROMSeg:Addr];
  end;
 end;

Procedure Poke(Addr:word;Value:byte);
 begin
  case addr of
   $0000..$CFFF : Mem[RAMSeg:Addr]:=Value;
   $D000..$DFFF : Mem[CIOSeg:Addr]:=Value;
   $E000..$FFFF : Mem[ROMSeg:Addr]:=Value;
  end;
 end;

Function Value(Addr:word):string;
 begin
  Value:=' ('+HexaW(Addr)+')= $'+HexaB(Peek(Addr))+' "'+chr(CHARSET2[Peek(Addr)])+'"';
 end;

Function GetBreakPoint:word;
 var
  key:char;
  val:byte;
  result:word;
 begin
  Write('Goto : $');
  val:=0;
  result:=0;
  repeat
   key:=readkey;
   case key of
    #0:readkey;
    #8:if val>0 then begin dec(val); result:=result div 16; write(key) end;
    '0'..'9':if val<4 then begin
              inc(val);
              result:=result*16+(ord(key)-ord('0'));
              write(key);
             end;
    'A'..'F':if val<4 then begin
              inc(val);
              result:=result*16+(ord(key)-ord('A')+10);
              write(key);
             end;
    'a'..'f':if val<4 then begin
              inc(val);
              result:=result*16+(ord(key)-ord('a')+10);
              write(upcase(key));
             end;
   end;
  until (key=#13)and(val=4);
  WriteLn;
  GetBreakPoint:=result;
 end;

Procedure PutKey(Key:byte);
 Const
 { PC Keys remaped for C=64 : 'a'->'A'; 'A'->'a'... }
  Keys:array[0..255] of byte=(
   $00,$01,$02,$03,$04,$05,$06,$07,$14,$03,$0A,$0B,$0C,$0D,$0E,$0F,$10,$11,
   $12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,$20,$21,$22,$23,
   $24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,$30,$31,$32,$33,$34,$35,
   $36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F,$40,$61,$62,$63,$64,$65,$66,$67,
   $68,$69,$6A,$6B,$6C,$6D,$6E,$6F,$70,$71,$72,$73,$74,$75,$76,$77,$78,$79,
   $7A,$5B,$5C,$5D,$5E,$5F,$60,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,
   $4C,$4D,$4E,$4F,$50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$7B,$7C,$7D,
   $7E,$7F,$80,$81,$82,$83,$84,$85,$86,$87,$88,$89,$8A,$8B,$8C,$8D,$8E,$83,
   $90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9A,$9B,$5C,$9D,$9E,$9F,$A0,$A1,
   $A2,$A3,$A4,$A5,$A6,$A7,$A8,$A9,$AA,$AB,$AC,$AD,$AE,$AF,$B0,$B1,$B2,$B3,
   $B4,$B5,$B6,$B7,$B8,$B9,$BA,$BB,$BC,$BD,$BE,$BF,$C0,$C1,$C2,$C3,$C4,$C5,
   $C6,$13,$91,$12,$CA,$9D,$CC,$1D,$CE,$CF,$11,$92,$94,$D3,$D4,$D5,$D6,$D7,
   $D8,$D9,$DA,$DB,$DC,$DD,$DE,$DF,$E0,$E1,$E2,$E3,$E4,$E5,$E6,$E7,$E8,$E9,
   $EA,$EB,$EC,$ED,$EE,$EF,$F0,$F1,$F2,$F3,$F4,$F5,$F6,$93,$F8,$F9,$FA,$FB,
   $FC,$5F,$FE,$FF
  );
 Var
  Count:byte;
 begin
 { Keyboard buffer key count }
  Count:=Mem[RAMSeg:$C6];
 { Keyboard buffer }
  Mem[RAMSeg:$277+Count]:=Keys[Key];
 { Update count }
  Mem[RAMSeg:$C6]:=Count+1;
 end;

const
  stop:boolean=true;
  breakpoint:word=0;
 {$ifdef trap16}
  echo:boolean=false;
  c64kb:boolean=true;
 {$else}
  echo:boolean=true;
  c64kb:boolean=false;
 {$endif}
  return:word=0;
  irq:boolean=false;
  full:boolean=false;


  index:word=238;

var
  Dump:string;
  ix,iy:integer;
  o1,o2,c:word;
  key:byte;
  k:char;

  ir:byte;
  pip2:word;
  pip1:byte absolute pip2;

procedure FullScreen;
 var
  o3:word;
 begin
  c:=COLOR[Mem[CIOSeg:$D021] AND 15] SHL 12;

  for iy:=0 to 24 do begin
   o1:=238+160*iy;
   o2:=40*iy;

   if Mem[CIOSeg:$D018] and 3 = 2 then begin

   for ix:=0 to 39 do
    MemW[SegB800:o1+2*ix]:=
     c+COLOR[Mem[CIOSeg:$D800+o2+ix] and 15] SHL 8+
     CHARSET2[Mem[RAMSeg:$0400+o2+ix]];

   end else begin

   for ix:=0 to 39 do
    MemW[SegB800:o1+2*ix]:=
     c+COLOR[Mem[CIOSeg:$D800+o2+ix] and 15] SHL 8+
     CHARSET1[Mem[RAMSeg:$0400+o2+ix]];

   end;

  end;

 end;

procedure DumpRegs;
 begin
  ir:=peek(PC);
  pip2:=deek(pc+1);

  TextColor(White);
  case PC of
   $A408 : WriteLn(#16' Check Memory');
   $AB1E : WriteLn(#16' Print string at AY');
   $B487 : WriteLn(#16' Get string');
   $E394 : WriteLn(#16' BASIC Reset');
   $E3BF : WriteLn(#16' Init BASIC Interpretor');
   $E422 : WriteLn(#16' BASIC Message');
   $E453 : WriteLn(#16' Init vectors $0300-$030B');
   $E4DA : WriteLn(#16' Set Color');
   $E518 : WriteLn(#16' Init Keyboard & Video');
   $E56C : WriteLn(#16' Set current line addr');
   $E5A0 : WriteLn(#16' Init Video');
   $E716 : WriteLn(#16' Output char to screen (device 3)');
   $E7D4 : WriteLn(#16' put MAJ on screen');
   $E9F0 : WriteLn(#16' Compute Char offset from X');
   $E9FF : WriteLn(#16' Clear line');
   $EA24 : WriteLn(#16' Compute Color offset');
   $EA31 : WriteLn(#16' Standard IRQ routine');
   $EA87 : WriteLn(#16' Check keyboard');
   $EE8E : Writeln(#16' Clock = 1');
   $EEA9 : WriteLn(#16' ');
   $F69B : WriteLn(#16' Incr. Real Time Clock');
   $FCE2 : WriteLn(#16' C=64 Entry point');
   $FCEF : WriteLn(#16' (no cartridge)');
   $FD02 : WriteLn(#16' Detect cartridge');
   $FD15 : WriteLn(#16' Restore I/O vectors');
   $FD1A : WriteLn(#16' Set I/O Vectors from XY');
   $FD50 : WriteLn(#16' Init z-page & search ROM');
   $FDA3 : WriteLn(#16' Reset I/O');
   $FDDD : WriteLn(#16' Check monitor');
   $FF5B : WriteLn(#16' Init I/O');
   $FF5E : WriteLn(#16' Wait retrace');
   $FF6E : WriteLn(#16' Set IRQs to 1/60s');
   $FF9C : WriteLn(#16' [Get/Set Bottom of memory]');
   $FF99 : WriteLn(#16' [Get/Set Top of memory]');
   $FFCF : WriteLn(#16' Start BASIC');
   $FFD2 : WriteLn(#16' [Output char]');
  end;
        {         1         2         3         4     }
        {1...:....0....:....0....:....0....:....0....:}
  Dump:='PC=xxxx OP=xx A=xx X=xx Y=xx P=nv0bdizc S=1xx ';

  PutHexaW(PC,Dump[ 4]);
  PutHexaB(ir,Dump[12]);
  PutHexaB(A ,Dump[17]);
  PutHexaB(X ,Dump[22]);
  PutHexaB(Y ,Dump[27]);

  if CFlag in P then Dump[39]:='C';
  if ZFlag in P then Dump[38]:='Z';
  if IFlag in P then Dump[37]:='I';
  if DFlag in P then Dump[36]:='D';
  if BFlag in P then Dump[35]:='B';
  if _Flag in P then Dump[34]:='1';
  if VFlag in P then Dump[33]:='V';
  if NFlag in P then Dump[32]:='N';

  PutHexaB(S AND $FF,Dump[44]);

  With OpCode[ir] do begin
   Dump:=Dump+Name+' ';
   Case Parm of
    pImpl : { nothing };
    pAbso : Dump:=Dump+ '$'+HexaW(pip2)+'   '+Value(pip2);
    pZPge : Dump:=Dump+ '$'+HexaB(pip1)+'     '+Value(pip1);
    pImm  : Dump:=Dump+'#$'+HexaB(pip1);
    pAbsX : Dump:=Dump+ '$'+HexaW(pip2)+'+X'+' '+Value(pip2+X);
    pAbsY : Dump:=Dump+ '$'+HexaW(pip2)+'+Y'+' '+Value(pip2+Y);
    pIndX : Dump:=Dump+'($'+HexaB(pip1)+'+X'+' '+Value(Deek(pip1+X));
    pIndY : Dump:=Dump+'($'+HexaB(pip1)+')+Y'+' '+Value(Deek(pip1+Y));
    pZPgX : Dump:=Dump+ '$'+HexaB(pip1)+'+X'+' '+Value(pip1+X);
    pZPgY : Dump:=Dump+ '$'+HexaB(pip1)+'+Y'+' '+Value(pip1+Y);
    pRela : Dump:=Dump+ '$'+HexaW(PC+2+ShortInt(pip1));
    pInd  : Dump:=Dump+'($'+HexaW(pip2)+')';
   end;
  end;

  if Dump[47]='J' then Dump[0]:=#57;

  if (ir=$40)or irq then TextColor(LightGreen) else TextColor(Yellow);

  WriteLn(Cycles:2,' ',Dump);
 end;

  procedure SwitchEcho;
   begin
    echo:=not echo;
    if echo then begin
     mem[SegB800:2*(10*80+11)]:=ord('N');
     mem[SegB800:2*(10*80+12)]:=ord(' ');
    end else begin
     mem[SegB800:2*(10*80+11)]:=ord('F');
     mem[SegB800:2*(10*80+12)]:=ord('F');
    end;
   end;

  procedure SwitchKbd;
   begin
    c64kb:=not c64kb;
    if c64kb then begin
     mem[SegB800:2*(11*80+19)]:=ord('N');
     mem[SegB800:2*(11*80+20)]:=ord(' ');
     TextColor(LightRed);
     WriteLn('Press <Esc> to restore PC keyboard...');
     stop:=false;
    end else begin
     mem[SegB800:2*(11*80+19)]:=ord('F');
     mem[SegB800:2*(11*80+20)]:=ord('F');
    end;
   end;

  procedure SwitchFullScreen;
   begin
    full:=not full;
    if full then begin
     mem[SegB800:2*(12*80+25)]:=ord('N');
     mem[SegB800:2*(12*80+26)]:=ord(' ');
    end else begin
     mem[SegB800:2*(12*80+25)]:=ord('F');
     mem[SegB800:2*(12*80+26)]:=ord('F');
    end;
   end;


Const
 KEYS:array[#1..#127] of word=(
 {   1    2    3    4    5    6    7   <-    9   10}
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$000,$0FF,$0FF,
 {  11   12   RT   14   15   16   17   18   19   20}
  $0FF,$0FF,$001,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,
 {  21   22   23   24   25   26   27   28   29   30}
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$00E,$0FF,$0FF,$0FF,
 {  31  ' '   33    "    #    $   37   38   39   40}
  $0FF,$074,$0FF,$173,$110,$113,$0FF,$0FF,$0FF,$0FF,
 {  41 42=* 43=+    ,    -   46   47    0    1    2}
  $0FF,$061,$050,$057,$053,$0FF,$0FF,$043,$070,$073,
 {   3    4    5    6    7    8    9    :    ;    <}
  $010,$013,$020,$023,$030,$033,$040,$055,$062,$157,
 {   =    >   F5   F6   F7   F8   67   68   69   70}
  $065,$154,$006,$106,$003,$103,$0FF,$0FF,$0FF,$0FF,
 {  71    2    3    4    5    6    7    8    9   10}
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,
 {  81    2    3    4    5    6    7    8    9   10}
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,
 {  91    2    3    4    5    6    A    B    C    D}
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$012,$034,$024,$022,
 {   E    F    G    H    I    J    K    L    M    N }
  $016,$025,$032,$035,$041,$042,$045,$052,$044,$047,
  $046,$051,$076,$021,$015,$026,$036,$037,$011,$027,
 {   Z }
  $031,$014,$0FF,$0FF,$0FF,$0FF,$0FF
 );
 XKEY:array[#1..#127] of word=(
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF, { 10 }
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF, { 20 }
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF, { 30 }
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF, { 40 }
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF, { 50 }
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF, { 60 }
                      { F7 }
  $0FF,$0FF,$0FF,$0FF,$003,$0FF,$0FF,$0FF,$0FF,$0FF, { 70 }
       {up} {pgu}     {lft}     {rgt}     {end}{dwn}
  $0FF,$107,$401,$0FF,$102,$0FF,$002,$0FF,$400,$007, { 80 }
  {pgd}     {<-}
  $402,$0FF,$000,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,
  $0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF
 );
var
 keystate:byte absolute $40:$17;
           { bit 7 =1 INSert active
             bit 6 =1 Caps Lock active
             bit 5 =1 Num Lock active
             bit 4 =1 Scroll Lock active
             bit 3 =1 either Alt pressed
             bit 2 =1 either Ctrl pressed
             bit 1 =1 Left Shift pressed
             bit 0 =1 Right Shift pressed }

procedure dbgKEYB; far;
 var
  k:char;
  c:word;
  col,row:byte;
 begin
  if c64kb and keypressed then begin
   k:=readkey;

   if k=#27 then begin
    stop:=true;
    SwitchKbd;
    exit;
   end;

   if k=#0 then begin
    k:=readkey;
    c:=XKEY[k];
    if c=$FF then write('extended ');
   end else begin
    c:=KEYS[k];
   end;

   if (keystate and 3>0) then { joystick }
    case c of
     $107:c:=$411;
     $007:c:=$412;
     $102:c:=$413;
     $002:c:=$414;
    end;

   case c of
    $FF : writeln('key #',ord(k));
   $400 : JoyState:=255-$10; { fire }
   $401 : Joystick:=1;
   $402 : Joystick:=2;
   $411 : JoyState:=255-1;
   $412 : JoyState:=255-2;
   $413 : JoyState:=255-4;
   $414 : JoyState:=255-8;
    else  begin
     col:=(c shr 4) and 7;
     row:=c and 7;
     if c>255 then begin
      KeyMatrix[Col]:=not (1 shl Row);
      RevMatrix[Row]:=not (1 shl Col);
     { shift }
      KeyMatrix[1]:=KeyMatrix[1] and not (1 shl 7);
      RevMatrix[7]:=KeyMatrix[7] and not (1 shl 1);
     end else begin
      KeyMatrix[Col]:=not (1 shl Row);
      RevMatrix[Row]:=not (1 shl Col);
     end;
    end;
   end;
  end;
 end;

procedure dbgVIC; far;
 var
  c,rc,ch,cl:word;
 begin
  iy:=(Raster-51) div 8;

  o1:=238+160*iy;

  mem[SegB800:index]:=32;
  index:=o1-2;
  mem[SegB800:index]:=16;

  rc:=COLOR[Mem[CIOSeg:$D021] AND 15] SHL 8;
  c:=COLOR[Mem[CIOSeg:$D021] AND 15] SHL 12;

  if Mem[CIOSeg:$D018] and 3 = 2 then begin

   for ix:=0 to 39 do begin
    ch:=VideoMatrix[ix];
    cl:=COLOR[ColorMatrix[ix] and 15];
    if ch<128 then
     MemW[SegB800:o1+2*ix]:=c+cl SHL 8+CHARSET2[ch]
    else
     MemW[SegB800:o1+2*ix]:=rc+cl SHL 12+CHARSET2[ch and 127]
   end;

  end else begin

   for ix:=0 to 39 do begin
    ch:=VideoMatrix[ix];
    cl:=COLOR[ColorMatrix[ix] and 15];
    if ch<128 then
     MemW[SegB800:o1+2*ix]:=c+cl SHL 8+CHARSET1[ch]
    else
     MemW[SegB800:o1+2*ix]:=rc+cl SHL 12+CHARSET1[ch and 127]
   end;
   {
    MemW[SegB800:o1+2*ix]:=
     c+COLOR[ColorMatrix[ix] and 15] SHL 8+CHARSET1[VideoMatrix[ix]];
   }
  end;
 end;

procedure dbgNMI; far;
 begin
  TextColor(White);
  if echo then WriteLn(#16' NMI [FFFA]=',HexaW(Deek($FFFA)));
  IRQ:=True;
 end;

procedure dbgIRQ; far;
 var
  port:byte;
  sep:char;
 begin
  TextColor(White);
  if echo then begin WriteLn(#16' IRQ [FFFE]=',HexaW(Deek($FFFE)));
   port:=(not Mem[RAMSeg:0]) or Mem[RAMSeg:1];
   Write(#16' Memory configuration (',HexaB(port),') :'); sep:=' ';
   if  (Port and 2)=2 then begin Write(sep,'KERNEL'); sep:='+'; end;
   if  (Port and 3)=3 then begin write(sep,'BASIC'); sep:='+'; end;
   if  (Port and 7)>4 then begin write(sep,'CHIPS'); sep:='+'; end else
   if  (Port and 3)>0 then begin write(sep,'CHARSET'); sep:='+'; end;
   if sep=' ' then begin write(' (no ROM)'); end;
   writeln;
  end;
  IRQ:=True;
 end;

procedure dbgBRK; far;
 begin
  TextColor(White);
  Writeln(#16' BRK at PC=',HexaW(PC-1),' (',HexaB(Peek(PC-1)),')');
 end;

procedure dbgPCRAM; far;
 var
  test:byte;
 begin
  if echo then begin
   if pc<$e000 then exit;
   TextColor(White);
   test:=(not Mem[RAMSeg:0]) or Mem[RAMSeg:1];
   if (test and 2)=2 then begin WriteLn('KERNEL !!!'); stop:=true; end;
   Writeln(#16' PC(RAM)=',HexaW(PC),' OpCode=',HexaB(Mem[RAMSeg:PC]));
  end;
 end;

procedure dbgDRAM; far;
 begin
  if echo then
   Writeln(#16' DeekRAM at ',
           HexaW(PC),'->',
           HexaW(Deek(PC)),' = ',
           HexaB(Peek(Deek(PC)))
           );
  if pc=$0BC4 then begin
   stop:=true;
  end;
 end;

procedure dbgPCROM; far;
 var
  test:byte;
 begin
  if echo then begin
   if pc>$a000 then exit;
   TextColor(White);
   test:=(not Mem[RAMSeg:0]) or Mem[RAMSeg:1];
   if (test and 2)<>2 then begin WriteLn('KERNEL !!!'); stop:=true; end;
   Writeln(#16' PC(ROM)=',HexaW(PC),' OpCode=',HexaB(Mem[ROMSeg:PC]));
  end;
 end;

procedure dbgDROM; far;
 begin
  if echo then Writeln(#16' DeekROM');
 end;

procedure dbgDCIO; far;
 begin
  if echo then Writeln(#16' DeekCIO');
 end;

procedure dbgKON; far;
 begin
  if echo then Writeln(#16' KERNEL On');
 end;

procedure dbgKOFF; far;
 begin
  if echo then Writeln(#16' KERNEL Off');
 end;

procedure dbgBON; far;
 begin
  if echo then Writeln(#16' BASIC On');
 end;

procedure dbgBOff; far;
 begin
  if echo then Writeln(#16' BASIC Off');
 end;

procedure MemInfo;
 var
  port:byte;
  sep:char;
 begin
  TextColor(White);
  port:=(not Mem[RAMSeg:0]) or Mem[RAMSeg:1];
  writeln('RAM:0=',HexaB(Mem[RAMSeg:0]));
  writeln('RAM:1=',HexaB(Mem[RAMSeg:1]));
  Write(#16' Memory configuration (',HexaB(port),') :'); sep:=' ';
  if  (Port and 2)=2 then begin Write(sep,'KERNEL'); sep:='+'; end;
  if  (Port and 3)=3 then begin write(sep,'BASIC'); sep:='+'; end;
  if  (Port and 7)>4 then begin write(sep,'CHIPS'); sep:='+'; end else
  if  (Port and 3)>0 then begin write(sep,'CHARSET'); sep:='+'; end;
  if sep=' ' then begin write(' (no ROM)'); end;
  writeln;
 end;

procedure dbgCFG; far;
 begin
  if echo then begin
   MemInfo;
  end;
 end;

procedure dbgVICLine; far;
 begin
  mem[SegB800:2*(21*80+11)]:=ord(Raster div 100)+ord('0');
  mem[SegB800:2*(21*80+12)]:=ord((Raster div 10)mod 10)+ord('0');
  mem[SegB800:2*(21*80+13)]:=ord(Raster mod 10)+ord('0');
 end;

procedure dbgVICIRQ; far;
 begin
  if echo then begin
   TextColor(White);
   WriteLn(#16' VIC IRQ at Raster ',Raster);
  end;
 end;

Procedure VicInfo;
 var
  m:byte;
 begin
  TextColor(LightGreen);
  WriteLn('  VIC Control Regsiter        (D016) = ',HexaB(Mem[CIOSeg:$D016]));
  WriteLn('  VIC Memory Control Register (D018) = ',HexaB(Mem[CIOSeg:$D018]));
  Write('  Video Mode : ');
  m:=((Mem[CIOSeg:53265] and $60) or (Mem[CIOSeg:53270]and$10)) shr 4;
  case m of
   0 : WriteLn('Standard Text');
   1 : WriteLn('MultiColor Text');
   2 : WriteLn('Standard Bitmap');
   3 : WriteLn('MultiColor Bitmap');
   4 : WriteLn('Extended Text');
   5 : WriteLn('Extended Multicolor Text');
   6 : WriteLn('Invalide Extended Bitmap');
   7 : WriteLn('Invalide Extended Multicolor bitmap');
  end;

  WriteLn('  Video Bank : $'+HexaW(Bank));

  WriteLn('  Scrolling  : X=$'+HexaB(Mem[CIOSeg:53265] and 7)+
                        ' Y=$'+HexaB(Mem[CIOSeg:53270] and 7));


  if m and 2=0 then begin
   WriteLn('  Video Ram  : $'+HexaW(VideoOfs));
   Write  ('  CharGen    : ');
   if Seg(CharGen^)=RAMSeg then Write('RAM') else
   if Seg(CharGen^)=ROMSeg then Write('ROM') else Write(HexaW(Seg(CharGen^)));

   WriteLn(':'+HexaW(Ofs(CharGen^)));
  end else begin
   WriteLn('  Bitmap Addres : $'+HexaW(BitmapOfs));
  end;
 end;

procedure dbgVICBase; far;
 begin
  if echo then begin
   TextColor(White);
   WriteLn(#16' VIC Base');
   VicInfo;
  end;
 end;

procedure dbgVICMode; far;
 begin
  if echo then begin
   TextColor(White);
   WriteLn(#16' VIC Mode');
   VicInfo;
  end;
 end;

procedure dbgDx16Before; far;
 begin
  if echo then begin
   TextColor(White);
   WriteLn(#16' VIC Dx16 - Before change = ',HexaB(Mem[CIOSeg:$D016]));
  end;
 end;

procedure dbgDx16After; far;
 begin
  if echo then begin
   TextColor(White);
   WriteLn(#16' VIC Dx16 - After change = ',HexaB(Mem[CIOSeg:$D016]));
  end;
 end;

procedure dbgPokeDC0D; far;
 var
  icr:byte;
 begin
  if echo then begin
   TextColor(White);
   WriteLn(#16' CIA1 Interrupt Control Register (DC0D)');
   icr:=Mem[CIOSeg:$DC0D];
   WriteLn(' 7 - IRQ    = ',(icr and $80)>0);
   WriteLn(' 4 - FLAG1  = ',(icr and $10)>0);
   WriteLn(' 3 - Serial = ',(icr and $08)>0);
   WriteLn(' 2 - Alarm  = ',(icr and $04)>0);
   WriteLn(' 1 - TimerB = ',(icr and $02)>0);
   WriteLn(' 0 - TimerA = ',(icr and $01)>0);
  end;
 end;

procedure CPUJAM; far;
 begin
  TextColor(Red);
  WriteLn(#16' Processor jamed ('+HexaB(opJAM)+')');
  DumpRegs;
 end;

function FileExist(filename:string):boolean;
 var
  h:word;
 begin
  h:=openfile(filename+#0,fmRead);
  FileExist:=(h>0);
  if h=0 then begin
   TextColor(Red);
   WriteLn('File not found');
  end else
   CloseFile(h);
 end;

procedure LoadPRG;
 Var
  PRG:String;
  Handle:word;
  Size:word;
  Offset:word;
 begin
  repeat
   TextColor(White);
   write('Enter P00/PRG File Name :');
   readln(PRG); if PRG='' then exit;
  until FileExist(PRG);

  Handle:=OpenFile(PRG,fmRead);
  if Handle=0 then exit;

  Size:=FileSize(Handle)-2;
  if PRG[Length(PRG)]='0' then begin { .P00 else .PRG }
   SeekFile(Handle,$1A);
   Dec(Size,$1A);
  end;
  ReadFile(Handle,Offset,2);
  ReadFile(Handle,Mem[RAMSeg:Offset],Size);
  CloseFile(Handle);

  Inc(Size,Offset);

  MemW[RAMSeg:$2B]:=Offset; { Start of BASIC Text Area ($0801) }
  MemW[RAMSeg:$2D]:=Size;   { Start of BASIC Variables }
  MemW[RAMSeg:$2F]:=Size;   { Start of BASIC Arrays    }
  MemW[RAMSeg:$31]:=Size+1; { End of BASIC Arrays +1   }
 end;


procedure dbgCPU; far;
 begin
{$IFNDEF TRAP16}
(*
  if PC=2073 then stop:=true; { DISK2.D64, TRAP4 }
  if PC=$D000 then stop:=true; { DISK2.D64, TRAP4 }
*)

 {$ifdef verify}
  TextColor(Red);
  if not (_Flag in P) then begin writeln('WARNIN _Flag = 0'); stop:=true; end;
  if A>255 then begin writeln('WARNING A=',HexaW(A)); stop:=true; end;
  if X>255 then begin writeln('WARNING X=',HexaW(X)); stop:=true; end;
  if Y>255 then begin writeln('WARNING Y=',HexaW(Y)); stop:=true; end;
  if S<256 then begin writeln('WARNING S=',HexaW(S)); stop:=true; end;
  if Raster>312 then begin writeln('WARNING Raster=',Raster); stop:=true; end;
 {$endif}

  if full then fullscreen;

  ir:=peek(PC);
  pip2:=deek(pc+1);

  if ir=$40 then irq:=false;

  if pc=breakpoint then stop:=true;
  if (return>0) then
   if (ir=$60) then begin
    dec(return);
    {if return=0 then stop:=true;}
   end else
    if (OpCode[ir].Name='JSR') then inc(return);

  if stop and c64kb then SwitchKbd;

  if c64kb then begin

   (*

   while keypressed do begin

    key:=ord(readkey); if key=0 then key:=128+ord(readkey);

    if key=27 then begin
     stop:=true;
     SwitchKbd;
     break;
    end else begin
     if key=187 then { for ERIK THE VIKING (press F1) }
      Mem[RAMSeg:$CB]:=$04
     else
      putkey(key);
    end;

   end;

   *)

  end else begin

   if (not stop)and keypressed then stop:=true;

  end;


  if echo or stop then begin

   DumpRegs;

{
  if IR in [$08,$20,$28,$48,$60,$68] then begin

   write('STACK : ');
   for i:=S+1 to $1FE do write(HexaB(Mem[Seg(Ram^):i]),',');
   writeLn(HexaB(Mem[Seg(Ram^):$1FF]));

  end;
}

  end; { echo }


  if (not c64kb)and(stop) then begin

  repeat
   write('?'); k:=readkey; if k=#0 then k:=chr(128+ord(readkey)); write(#8);
   case k of
    'r','R'     : begin BreakPoint:=0; stop:=false; end;
    'p','P'     : with OpCode[ir] do
                   if Name='JSR' then begin
                    BreakPoint:=pc+3; stop:=false;
                   end else begin
                    if Parm<>pRela then exit;
                    BreakPoint:=pc+2; stop:=false;
                   end;
    'b','B'     : begin
                   if OpCode[ir].Parm<>pRela then exit;
                   BreakPoint:=pc+1+ShortInt(Peek(pc+1));
                   stop:=false;
                  end;
    's','S'     : begin
                   if OpCode[ir].Parm<>pRela then exit;
                   BreakPoint:=pc+2;
                   stop:=false;
                  end;
    'x','X'     : begin return:=1; stop:=false end;
    'e','E'     : SwitchEcho;
    'f','F'     : SwitchFullScreen;
    'k','K'     : SwitchKbd;
    'l','L'     : LoadPRG;
    't','T',#13 : exit;
    'm','M'     : MemInfo;
    'q','Q',#27 : halt;
            #0  : readkey;
        'g','G' : begin BreakPoint:=GetBreakPoint; stop:=false; end;
    else writeln('k=#',ord(k));
   end;
  until stop=false;

  if not echo then writeln('running...');

  end;
{$ENDIF}
 end;

{ IEC }
Const
 LastIEC:char=' ';

Procedure dbgOutput; far;
 begin
  {if Echo then} begin
   if LastIEC<>'o' then begin
    TextColor(White);
    Write(#16,'IEC Output ');
    LastIEC:='o';
   end;
   Write(chr(CHARSET2[Mem[RAMSeg:$95]]));
   if (Mem[RAMSeg:$A3] and $80)>0 then write('<EOF>');
  end;
  IEC.Output;
 end;

Procedure dbgOutputATN; far;
 begin

  if D64.D64File='' then begin
   repeat
    TextColor(White);
    write('Enter D64 File Name :');
    readln(D64.D64File);
    if not FileExist(D64.D64File) then D64.D64File:='';
   until D64.D64File<>'';
  end;

  {if echo then} begin
  if LastIEC='o' then writeln;
  LastIEC:='a';
  TextColor(White);
  Write(#16,'IEC OutputATN :');
  Write(' DEV=',A and 15);
  Write(' ATN=');
  case A and $F0 of
   ATN_LISTEN   : Write('LISTEN');
   ATN_UNLISTEN : Write('UNLISTEN');
   ATN_TALK     : Write('TALK');
   ATN_UNTALK   : Write('UNTALK');
   else write(HexaB(A and $F0));
  end;
  writeln;
  end;
  IEC.OutputATN;
 end;

Procedure dbgOutputSEC; far;
 begin
  if (A and $F=CMD_DATA)and(A and $F<>15)and(D64.D64File='') then begin
   repeat
    TextColor(White);
    write('Enter D64 File Name :');
    readln(D64.D64File);
    if not FileExist(D64.D64File) then D64.D64File:='';
   until D64.D64File<>'';
  end;

  if echo then begin
  LastIEC:='s';
  TextColor(White);
  Write(#16,'IEC OutputSEC :');
  Write(' SEC=',A and $F);
  Write(' CMD=');
  Case A and $F0 of
   CMD_OPEN  : Write('OPEN');
   CMD_CLOSE : Write('CLOSE');
   CMD_DATA  : Write('DATA');
   else write(HexaB(A and $F0));
  end;
  writeln;
{  stop:=true; }
  end;
  IEC.OutputSEC;
 end;

Procedure dbgInput; far;
 begin
  if echo then begin
  if LastIEC<>'i' then begin
   TextColor(White);
   Write(#16,'IEC Input');
   LastIEC:='i';
   WriteLn('.');
  end;
{  stop:=true;}
  end;
  IEC.Input;
 end;

Procedure dbgPokeSID; far;
 begin
  if echo then begin
   TextColor(White);
   writeln(#16' SID : POKE ',HexaW(SIDAddr),',',HexaB(SIDPoke));
   {$IFDEF SID}
   PokeSid;
   {$ENDIF}
  end;
 end;

{$IFNDEF SID}
Procedure ResetFM; far;
 begin
 end;
{$ENDIF}

procedure READTAPE; far;
 begin
  writeln(#16'TAPE NOT EMULATED !');
  stop:=true;
 end;

begin
 if paramcount>0 then D64.D64File:=Paramstr(1);

{ build ASCII->PSET }
 For x:=0 to 255 do CHARSET1[x]:=x;
 For X:=0 to 26  do CHARSET1[x]:=Ord('@')+x;
 CHARSET1[Ord('')]:=ord('');

 For x:=0 to 255 do CHARSET2[x]:=x;
 For X:=0 to 26  do CHARSET2[x]:=96+x;
 CHARSET2[Ord('')]:=ord('');

{ Draw Screen }
 TextMode(CO80+Font8x8);
 TextAttr:=$07;
 ClrScr;
 WriteLn('C=64 interractive debugger');
 WriteLn('');
 WriteLn;
 WriteLn(' T = Trace');
 WriteLn(' P = Proceed (skip)');
 WriteLn(' B = Branch  (proceed until)');
 WriteLn(' S = Skip    (proceed until)');
 WriteLn(' X = eXit    (until RET)');
 WriteLn(' G = Goto');
 WriteLn(' R = Run');
 WriteLn(' E = Echo ON');
 WriteLn(' K = C64 Keyboard OFF');
 WriteLn(' F = refesh Full screen OFF');
 WriteLn(' L = Load P00/PRG');
 WriteLn(' Q = Quit');
 WriteLn(' M = Memory info');
 WriteLn;
 WriteLn(' Pge Up = Joy#1');
 WriteLn(' Pge Dwn= Joy#2');
 WriteLn(' End    = Fire');
 WriteLn;
 WriteLn(' Raster =   0');
 GotoXY(1,25);
 WriteLn('Copyright (C) 1997-98, Paul TOTH');
 WriteLn(' <tothpaul@multimania.com>');
 Window(39,1,80,27);
 asm mov ax,$1003; mov bl,0; int 10h end; { no blink = 16 color background }
 TextAttr:=$91; clrscr;
 Window(40,2,79,26);
 TextAttr:=$19; ClrScr;
 Window(1,28,80,50);
 TextAttr:=$1E; clrscr;
 Window(2,29,79,49);

{ RAM : 0000-FFFF }
{ ROM : 0000-1FFF - BASIC (A000-BFFF) }
{     : 2000-2FFF - CHIPS (D000-DFFF) }
{     : 3000-3FFF - CHARS (D000-DFFF) }
{     : 4000-5FFF - KERNL (E000-FFFF) }

 GetMem(RAM,$FFFF); RAMSeg:=Seg(RAM^);
 GetMem(ROM,$6000); ROMSeg:=Seg(ROM^)-$0A00;
                    CIOSeg:=Seg(ROM^)-$0D00+$0200;
{$IFDEF SID}
 SIDFM.Init;
{$ENDIF}

 StartUp;

 Emulate;

{$IFDEF SID}
 SIDFM.Done;
{$ENDIF}

 WriteLn(#16' Emulator terminated at PC=',HexaW(PC),' on opcode ',HexaB(Peek(PC)));
end.
