Unit IEC;

Interface

{ BIG BUG Correction !!!!

 Previous version use ATN_TALK to open a file
 BUT we have to open the file at EOF on OUT !!!!

}

{
 E156 : ; SAVE
        ...
        JSR FFD8->JMP F5DD ; SAVE RAM(ZPGE[A]..(XY)-1) ON DEV([BA])
                                  FILENAME at [BB,CC] Lenght=[B7]

}

{ LOAD "$",8
  ----------

   ATN Listen(8)  -> OK  // OpenDevice
   SEC 0,OPEN     -> Name:=''
   OUT "$"        -> Name:=Name+Chr(OUT)
   ATN Unlisten

   ATN Talk(8)
   SEC 0,DATA     -> If OpenDevice then LoadFile
   INP ...EOI     -> ReadByte -> ST_FILENOTFOUND (ST_READ_TIMEOUT)

   ATN Listen(8)
   SEC 0,CLOSE
   ATN Unlisten


  SAVE "TOTO",8
  -------------

   ATN Listen(8)  -> OpenDevice
   SEC 1,OPEN     -> Name:=''
   OUT "TOTO"     -> Name:=Name+Chr(OUT)
   ATN Unlisten

   ATN Listen(8)
   SEC 1,DATA     -> If OpenDevice then WriteFile
   OUT ........   -> WriteByte (ZPge[$95])
   ATN Unlisten

   ATN Listen(8)
   SEC 1,CLOSE
   ATN Unlisten

}

{-$DEFINE DEBUG}
uses
 d64,prg,fdos,DATA,Dialogs;

Procedure OutputATN;
Procedure OutputSEC;
Procedure Output;
Procedure Input;

Procedure ChangeDisk;

Const
{ C64 status codes }
 ST_OK           = $00;	{ No error }
 ST_READ_TIMEOUT = $02;	{ Timeout on reading }
 ST_TIMEOUT      = $03; { Timeout }
 ST_EOF          = $40; { End of file }
 ST_NOTPRESENT   = $80; { Device not present }

 ST_FILENOTFOUND = ST_READ_TIMEOUT;

{ IEC command codes }
 ATN_LISTEN   = $20;
 ATN_UNLISTEN = $30;
 ATN_TALK     = $40;
 ATN_UNTALK   = $50;

{ IEC command codes }
 CMD_DATA =$60; { Data transfer }
 CMD_CLOSE=$E0; { Close Channel }
 CMD_OPEN =$F0; { Open Channel  }

Implementation

Var
 ATN:byte;
 DEV:byte;
 SEC:byte;
 CMD:byte;

 FileName:string; { .D64 or .P00 or .PRG }
 Name    :string; { File to LOAD (D64)   }

Function LoadFile:byte;
 begin
  LoadFile:=ST_NOTPRESENT;
  Case DEV of
   8:if D64.OpenDevice then LoadFile:=D64.Load(SEC,Name);
  end;
 end;

Function SaveFile:byte;
 begin
  SaveFile:=ST_NOTPRESENT;
  Case DEV of
   8:if D64.OpenDevice then SaveFile:=D64.Save(SEC,Name);
  end;
 end;

Function ReadByte:byte;
 begin
  ReadByte:=ST_NOTPRESENT;
  Case DEV of
   8:ReadByte:=D64.ReadByte(SEC); { ST_FILENOTFOUND when D64.Load<>ST_OK }
  end;
 end;

Function WriteByte(b:byte;eof:boolean):byte;
 begin
  WriteByte:=ST_NOTPRESENT;
  Case DEV of
   8: WriteByte:=D64.WriteByte(SEC,b,eof);
  end;
 end;

{ Output one byte with ATN (Talk/Listen/Untalk/Unlisten) }
Procedure OutputATN; { ED23 }
 Var
  Result:Byte;
 begin
  Result:=ST_TIMEOUT;

  ATN:=A and $F0; {Listen/UnListen/Talk/UnTalk}
  DEV:=A and $0F; {8     /15      /8   /15    }

  Case ATN of
   ATN_LISTEN,ATN_TALK     : if DEV= 8 then Result:=ST_OK else Result:=ST_NOTPRESENT;{Result:=OpenDevice;}
   ATN_UNLISTEN,ATN_UNTALK : if DEV=15 then Result:=ST_OK;
  end;


  Mem[RAMSeg:$90]:=Mem[RAMSeg:$90] or Result;
  {if Result<>ST_OK then P:=P+[CFlag];}
 end;

Procedure OutputSEC; { ED36 }
 Var
  Result:byte;
 begin
  Result:=ST_TIMEOUT;
  if DEV<>8 then exit;

  CMD:=A and $F0; { Listen:CMD_OPEN/CMD_CLOSE/CMD_DATA, Talk:CMD_DATA }
  SEC:=A and $0F; {        0/1      0/1       0/1            0        }

  Case ATN of

   ATN_LISTEN :
    Case CMD of
     CMD_OPEN : begin
                 if SEC=15 then D64.Command:='' else Name:='';
                 Result:=ST_OK;
                end;
     CMD_CLOSE: Result:=ST_OK;
     CMD_DATA : Result:=ST_OK;
    end;

   ATN_TALK :
    Case CMD of
     CMD_DATA : Result:=ST_OK;
    end;

  end;

  Mem[RAMSeg:$90]:=Mem[RAMSeg:$90] or Result;
  {if Result<>ST_OK then P:=P+[CFlag];}
 end;

Procedure Output; { ED40 - Output ZPge[$95] to Serial bus }
                  {      - ZPge[$A3] and $80 = EndOfFile  }
 Var
  Result:byte;
  c:char;
  e:boolean;
 begin
  Result:=ST_TIMEOUT;
  if DEV<>8 then exit;

  c:=chr(Mem[RAMSeg:$95]);
  e:=(Mem[RAMSeg:$A3] and $80)>0;

  Case ATN of

   ATN_LISTEN:

    Case CMD of

     CMD_OPEN : begin

      Result:=ST_OK;

      if SEC=15 then begin
       Command:=Command+c;
       if e then ExecCommand;
      end else begin
       Name:=Name+c; { FILE NAME }
       if e then if SEC=1 then Result:=SaveFile else Result:=LoadFile;
      end;

     end;

     CMD_DATA : Result:=WriteByte(ord(c),e) { SAVE }
    end;

  end;

  Mem[RAMSeg:$90]:=Mem[RAMSeg:$90] or Result;
  {if Result<>ST_OK then P:=P+[CFlag];}
 end;

Procedure Input; { EE13 - A = ReadByte }
 Var
  Result:byte;
 begin
  Result:=ST_TIMEOUT;
  if DEV<>8 then exit;

  A:=0;

  Case ATN of

   ATN_TALK:
    Case CMD of
     CMD_DATA: Result:=ReadByte; { LOAD }
    end;

  end;

  Mem[RAMSeg:$90]:=Mem[RAMSeg:$90] or Result;
  {if Result<>ST_OK then P:=P+[CFlag];}
 end;


procedure ChangeDisk;
 begin
  if SelectFile('Select a File','D64 P00 PRG',FileName) then begin
   D64.CloseDevice;
   if FileName[length(FileName)]='4' then begin
    D64File:=FileName;
    D64.OpenDevice;
   end else begin
    LoadPRG(FileName);
   end;
  end;
 end;

end.