Unit Keyboard;

Interface

Var
 KeyCount :word;
 KeyStart :word;
 KeyBuffer:array[0..255] of byte;
 KeyState :byte;
 KeyDown  :byte;

Const
 key_up=200;
 key_left=205;
 key_right=203;
 key_down=208;
 key_home=199;
 key_end=207;
 key_pgeup=201;
 key_pgedown=209;
 key_escape=27;
 key_return=13;

Function GetKey:byte;

Implementation

Function GetKey:byte; assembler;
 asm
 {
  @WaitNoKey:
   TEST KeyDown,255
  JNZ @WaitNoKey

  CLI
   MOV AX,KeyStart
   MOV KeyCount,AX
  STI
 }
  @WaitKey:
   MOV BX,KeyStart
   CMP BX,KeyCount
  JE  @WaitKey

  CLI
   INC BL
   MOV AL,[BX+Offset KeyBuffer]
   MOV KeyStart,BX
  STI

  MOV BX,AX
  AND BX,7Fh

  TEST KeyState,1 { Extended }
  JZ @StandardKey

   AND KeyState,255-1

   CMP BL,2Ah
   JE  @SetXShift
   CMP BL,38h
   JE  @SetAltGr

   CMP AL,$47; JNE @1; MOV AL,Key_Home; JMP @Done
@1:CMP AL,$48; JNE @2; MOV AL,Key_Up;   JMP @Done
@2:CMP AL,$49; JNE @3; MOV AL,Key_PgeUp;JMP @Done
@3:CMP AL,$4B; JNE @4; MOV AL,Key_Left; JMP @Done
@4:CMP AL,$4D; JNE @5; MOV AL,Key_Right;JMP @Done
@5:CMP AL,$4F; JNE @6; MOV AL,Key_End;  JMP @Done
@6:CMP AL,$50; JNE @7; MOV AL,Key_Down; JMP @Done
@7:CMP AL,$51; JNE @WaitKey; MOV AL,Key_PgeDown; JMP @Done

  @SetXShift:
   AND KeyState,255-2
   TEST AL,80h
   JNZ @WaitKey
   OR KeyState,2
  JMP @WaitKey

  @SetAltGr:
   AND KeyState,255-4
   TEST AL,80h
   JNZ @WaitKey
   OR KeyState,4
  JMP @WaitKey

 @StandardKey:

  CMP BL,2Ah
  JE  @SetLShift
  CMP BL,36h
  JE  @SetRShift
  CMP AL,0E0h
  JE  @SetXState
  CMP BL,0E1h
  JE  @WaitKey

   CMP AL,$01; JNE @A; MOV AL,Key_Escape; JMP @DONE
@A:CMP AL,$1C; JNE @WaitKey; MOV AL,Key_Return; JMP @DONE

  @SetLShift:
   AND KeyState,255-8
   TEST AL,80h
   JNZ @WaitKey
   OR KeyState,8
  JMP @WaitKey

  @SetRShift:
   AND KeyState,255-16
   TEST AL,80h
   JNZ @WaitKey
   OR KeyState,16
  JMP @WaitKey

  @SetXState:
   OR KeyState,1
  JMP @WaitKey

 @Done:
 {
  @WaitNoKey1:
   TEST KeyDown,255
  JNZ @WaitNoKey1

  CLI
   MOV AX,KeyStart
   MOV KeyCount,AX
  STI
 }
 end;

end.