;-- POKE C64 Memory

;===============================================================
.DATA
Align 2
	      ; 0xxx 1xxx,2xxx,3xxx,4xxx,5xxx,6xxx,7xxx
PokeTable    dw sZPG,sRAM,sRAM,sRAM,sRAM,sRAM,sRAM,sRAM
	      ; 8xxx,9xxx,Axxx,Bxxx,Cxxx,Dxxx,Exxx,Fxxx
	     dw sRAM,sRAM,sRAM,sRAM,sRAM,sCIO,sRAM,sRAM

	      ; D0xx D1xx D2xx D3xx D4xx D5xx D6xx D7xx
PokeCIOTable dw wVIC,wVIC,wVIC,wVIC,wSID,wSID,wSID,wSID
	      ; D8xx D9xx DAxx DBxx DCxx DDxx DExx DFxx
	     dw wCOL,wCOL,wCOL,wCOL,wCI1,wCI2,wCOL,wCOL

;===============================================================
.CODE

;--- POKE(BX)
BEGINP PokeBX
 MOV DI,BX
 SHR BX,12
 JMP32 EBX, PokeTable ;-- JMP [2*EBX+Offset PokeTable]
PokeBX ENDP

;--- POKE(DI) -- for OP ABSO cause the peek destroy BX !!
BEGINP PokeDI
 MOV BX,DI
 SHR BX,12
 JMP32 EBX, PokeTable ;-- JMP [2*EBX+Offset PokeTable]
PokeDI ENDP

BEGINP sZPG
 MOV RAM:[DI],AL
 CMP DI,1      ; bug fix v2.5 (Frodo bug !)
 JE  ConfigMem
 JMP NEXT
sZPG ENDP

;===============================================================
BEGINP ConfigMem
;		if(address==1)
;		{
;			ret&=0x3F;
;			RAMPointer[1]&=~RAMPointer[0];
;			RAMPointer[1]|=ret&RAMPointer[0];
;		}

;comment !--
 MOV AL,RAM:[1] ; for Reset
 AND AL,3Fh     ; ret&=0x3F
 MOV BX,RAM:[0] ; - RAMPointer[0], RAMPointer[1]
 AND AL,BL      ; - ret&RAMPointer[0]
 NOT BL         ; - ~RAMPointer[0];
 AND BL,BH      ; RAMPointer[1]&=~RAMPointer[0];
 OR  AL,BL      ; RAMPointer[1]|=ret&RAMPointer[0];
 MOV RAM:[1],AL
comment !--
 MOV AH,RAM:[0] ; MOV AL in V2.4 :(
 MOV AL,RAM:[1]
 NOT AH
 OR  AL,AH
 AND AL,3Fh
 MOV RAM:[1],AL
!
 IF DEBUG
  CALLP dbgCFG
 ENDIF

 MOV BX,  0Eh   ; KERNEL ---------------------------------
 MOV DI,2*0Eh

 TEST AL,2      ; HIRAM (0=Kernal ROM out, Basic ROM out)
 JNZ SET_KERNAL

  IF DEBUG
   CALLP dbgKOFF
  ENDIF
  MOV WORD PTR [BX+Offset PeekPCTable],Offset pcRAM
  MOV WORD PTR [DI+Offset PeekTable]  ,Offset pRAM
  MOV WORD PTR [DI+Offset DeekTable]  ,Offset dRAM
  MOV WORD PTR [DI+Offset PeekTable+2],Offset pRAM
  MOV WORD PTR [DI+Offset DeekTable+2],Offset dRAM

 REMOVE_BASIC:
  MOV BX,  0Ah ; BASIC out ----------------------------
  MOV DI,2*0Ah

  IF DEBUG
   CALLP dbgBOFF
  ENDIF
  MOV WORD PTR [BX+Offset PeekPCTable],Offset pcRAM
  MOV WORD PTR [DI+Offset PeekTable]  ,Offset pRAM
  MOV WORD PTR [DI+Offset DeekTable]  ,Offset dRAM
  MOV WORD PTR [DI+Offset PeekTable+2],Offset pRAM
  MOV WORD PTR [DI+Offset DeekTable+2],Offset dRAM

 JMP KERNAL_DONE

 SET_KERNAL:
  IF DEBUG
   CALLP dbgKON
  ENDIF
  MOV WORD PTR [BX+Offset PeekPCTable],Offset pcROM
  MOV WORD PTR [DI+Offset PeekTable]  ,Offset pROM
  MOV WORD PTR [DI+Offset DeekTable]  ,Offset dROM
  MOV WORD PTR [DI+Offset PeekTable+2],Offset pROM
  MOV WORD PTR [DI+Offset DeekTable+2],Offset dROM

  TEST AL,1    ; LORAM (0=Basic ROM Out)
  JZ  REMOVE_BASIC

  MOV BX,  0Ah ; BASIC on
  MOV DI,2*0Ah

  IF DEBUG
   CALLP dbgBON
  ENDIF
  MOV WORD PTR [BX+Offset PeekPCTable],Offset pcROM
  MOV WORD PTR [DI+Offset PeekTable]  ,Offset pROM
  MOV WORD PTR [DI+Offset DeekTable]  ,Offset dROM
  MOV WORD PTR [DI+Offset PeekTable+2],Offset pROM
  MOV WORD PTR [DI+Offset DeekTable+2],Offset dROM

 KERNAL_DONE: ;----------------------------------------

 MOV BX,2*0Dh  ; CHIPS/CHARGEN/RAM
 MOV DI,  0Ch  ; pcCHR and pcCIO take care of C000-CFFF/D000-DFFF - v2.5 !

 MOV AH,AL
 AND AH,3      ; LO/HIRAM = BASIC or KERNEL In
 JNZ TEST_CHARSET
 ; Config 4,8,12,13..,24
  MOV WORD PTR [BX+Offset PeekTable],Offset pRAM
  MOV WORD PTR [BX+Offset DeekTable],Offset dRAM
  MOV WORD PTR [BX+Offset PokeTable],Offset sRAM
  MOV WORD PTR [DI+Offset PeekPCTable],Offset pcRAM
 JMP NEXT

 TEST_CHARSET:
 TEST AL,4     ; CHAREN (1=CHARSET ROM out)
 JNZ SET_CHIPS
 ; Config 1,2,3,9,10,11,25,26,27
  MOV WORD PTR [BX+Offset PeekTable],Offset pROM
  MOV WORD PTR [BX+Offset DeekTable],Offset dROM
  MOV WORD PTR [BX+Offset PokeTable],Offset sRAM
  MOV WORD PTR [DI+Offset PeekPCTable],Offset pcRAM ; pcCHR ???
 JMP NEXT

 SET_CHIPS: ; Config 5,6,7 = 4+any ROM
  MOV WORD PTR [BX+Offset PeekTable],Offset pCIO
  MOV WORD PTR [BX+Offset DeekTable],Offset dCIO
  MOV WORD PTR [BX+Offset PokeTable],Offset sCIO
  MOV WORD PTR [DI+Offset PeekPCTable],Offset pcCIO
 JMP NEXT ;-------------------------------------------

ConfigMem ENDP

BEGINP sRAM
 MOV RAM:[DI],AL
 JMP NEXT
sRAM ENDP

;--- POKE($Dxxx)
BEGINP sCIO

;-- MOV CIO:[DI],AL

 MOV BX,DI
 SHR BX,8
 AND BX,0Fh
 JMP32 EBX, PokeCIOTable ;-- JMP [2*EBX+Offset PokeCIOTable]
sCIO ENDP

BEGINP wVIC
 AND DI,0F03Fh ; Patch VIC Adresse !
 MOV BX,DI
 AND BX,03Fh
 JMP32 EBX, PokeVICTable ;-- JMP [2*EBX+Offset PokeVICTable]
wVIC ENDP

 .DATA
IF DEBUG
 EXTRN dbgPokeSID:FAR
ELSE
 EXTRN PokeSID:FAR
ENDIF
 EXTRN SIDPoke :BYTE
 EXTRN SIDAddr :WORD
 .CODE

BEGINP wSID
 AND DI,0D41Fh ; Patch SID Adresse !

 MOV AH,CIO:[DI]
 MOV CIO:[DI],AL

 AND DI,001Fh
;IFE DEBUG
 MOV SIDAddr,DI
 MOV SIDPoke,AL
IF DEBUG
 CALLP dbgPokeSID
ELSE
 CALLP PokeSID
ENDIF
;ENDIF
 JMP NEXT
wSID ENDP

BEGINP wCOL
 AND AL,15
 MOV CIO:[DI],AL
 JMP NEXT
wCOL ENDP

BEGINP wCI1
 AND DI,0FF0Fh ; Patch CIA Adresse !
 MOV BX,DI
 AND BX,15
 JMP32 EBX, PokeCIA1 ;-- JMP [2*EBX+Offset PokeCIA1]
wCI1 ENDP

BEGINP wCI2
 AND DI,0FF0Fh ; Patch CIA Adresse !
 MOV BX,DI
 AND BX,15
 JMP32 EBX, PokeCIA2 ;-- JMP [2*EBX+Offset PokeCIA2]
wCI2 ENDP

