Unit VGA;

Interface

{$G+}

Procedure Mode13h;
Procedure TextMode;
Procedure PutPixel(x,y,c:word);
Procedure Box(Left,Top,Width,Height,Color:word);
Procedure Frame3D(left,top,width,height,Light,Shadow,Background:word);
Procedure OutTextXY(x,y,c:word;const Text:String);
Procedure HLine(x,y,w,c:word);

Const
 clBlack      =0;
 clWhite      =1;
 clRed        =2;
 clCyan       =3;
 clPurple     =4;
 clGreen      =5;
 clBlue       =6;
 clYellow     =7;
 clOrange     =8;
 clBrown      =9;
 clLightRed   =10;
 clDarkGrey   =11;
 clGrey       =12;
 clLightGreen =13;
 clLightBlue  =14;
 clLightGrey  =15;

Implementation

uses
 c64rom,data;

Const
 Palette:array[0..15,0..2] of byte=(
  ($00,$00,$00), { 0 - Black    }
  ($3F,$3F,$3F), { 1 - White    }
  ($2E,$00,$05), { 2 - Red      }
  ($00,$30,$2B), { 3 - Cyan     }
  ($25,$00,$26), { 4 - Purple   }
  ($09,$33,$00), { 5 - Green    }
  ($01,$04,$2C), { 6 - Blue     }
  ($3F,$3F,$00), { 7 - Yellow   }
  ($26,$15,$00), { 8 - Orange   }
  ($14,$08,$05), { 9 - Brown    }
  ($3F,$14,$1E), { 10- Lt.Red   }
  ($12,$12,$12), { 11- Dk.Grey  }
  ($1C,$1C,$1C), { 12- Grey     }
  ($17,$3F,$15), { 13- Lt.Green }
  ($15,$1C,$3A), { 14- Lt.Blue  }
  ($2B,$2B,$2B)  { 15- Lt.Grey  }
 );


 LineSize:word=320;

Procedure Mode13h; assembler;
  asm
  { Bios mode 320x200 }
   mov ax,13h; int 10h

  { Clear Screen }
   mov ax,$0000
   mov es,SegA000
   xor di,di
   mov cx,320*200/2
   rep stosw

  { setup colors }
   mov dx,$3C8
   mov al,0
   out dx,al
   inc dx
   mov si,offset Palette
   mov cx,3*16
   rep outsb
 end;

Procedure TextMode; assembler;
 asm
  mov ax,03h; int 10h
 end;

Procedure PutPixel(x,y,c:word); assembler;
 asm
  mov ax,y
  mul LineSize
  add ax,x
  mov es,SegA000
  mov di,ax
  mov ax,c
  mov es:[di],al
 end;

Procedure HLine(x,y,w,c:word); assembler;
 asm
  mov ax,y
  mul LineSize
  add ax,x
  mov es,SegA000
  mov di,ax
  mov cx,w
  mov ax,c
  rep stosb
 end;

Procedure VLine(x,y,h,c:word); assembler;
 asm
  mov ax,y
  mul LineSize
  add ax,x
  mov es,SegA000
  mov di,ax

  mov cx,h
  @NextLine:
   mov es:[di],al
   add di,320
  loop @NextLine
 end;

Procedure Box(Left,Top,Width,Height,Color:word);
 var
  h:word;
 begin
  if Width=1 then
   VLine(Left,Top,Height,Color)
  else
   for h:=1 to Height do begin
    HLine(Left,Top,Width,Color);
    inc(top);
   end;
 end;

Procedure Frame3D(left,top,width,height,Light,Shadow,Background:word);
 begin
  Box(Left,Top,Width,Height,BackGround);
  HLine(Left,Top,Width,Light);
  VLine(Left,Top,Height,Light);
  HLine(Left,Top+Height-1,Width,Shadow);
  VLine(Left+Width-1,Top,Height,Shadow);
 end;

Type
 TRom8x8=array[#0..#255,0..7] of byte;

Var
 rom8x8:^Trom8x8;

Procedure OutTextXY(x,y,c:word;const Text:String);
 var
  is,ix,iy:integer;
  b:byte;
 begin
  is:=0;
 { While Text[is]<>#0 do begin }
  for is:=1 to length(Text) do begin

   for iy:=0 to 7 do begin
    b:=rom8x8^[text[is],iy];

    for ix:=0 to 7 do begin
     if b>127 then putpixel(x+ix,y+iy,c);
     b:=byte(b shl 1);
    end;

   end;

   inc(x,8);

 {  inc(is); }
  end;
 end;

begin
 asm
 push bp
  mov ax,1130h
  mov bh,03h
  int 10h
  mov word(rom8x8+0),bp
  mov word(rom8x8+2),es
 pop  bp
 end;
end.